--- Assumes that background image is of size
--- XXX
--- XOX
--- Where each character is the size of the screen, and 'O' is the default view.
function getDrawOffset(ballX, ballY)
    local offsetX, offsetY
    if ballY > C.Screen.H or ballX >= C.BallOffscreen then
        return 0, 0
    end
    offsetY = math.max(0, -1 * ballY)

    if ballX > 0 and ballX < C.Screen.W then
        offsetX = 0
    elseif ballX < 0 then
        offsetX = math.max(-1 * C.Screen.W, ballX * -1)
    elseif ballX > C.Screen.W then
        offsetX = math.min(C.Screen.W * 2, (ballX * -1) + C.Screen.W)
    end

    return offsetX * 1.3, offsetY * 1.5
end

-- selene: allow(unscoped_variables)
blipper = {}

--- Build an object that simply "blips" between the given images at the given interval.
--- Expects `playdate.graphics.animation.blinker.updateAll()` to be called on every update.
function blipper.new(msInterval, image1, image2)
    local blinker = playdate.graphics.animation.blinker.new(msInterval, msInterval, true)
    blinker:start()
    return {
        blinker = blinker,
        image1 = image1,
        image2 = image2,
        draw = function(self, disableBlipping, x, y)
            local currentImage = (disableBlipping or self.blinker.on) and self.image2 or self.image1
            currentImage:draw(x, y)
        end,
    }
end

--selene: allow(unscoped_variables)
PlayerImageBlipper = blipper.new(100, Player, PlayerLowHat)
